document.addEventListener('consent.ready', function(e) {
	giveConsentEtracker(e.detail);
});
document.addEventListener('consent.updated', function(e) {
	giveConsentEtracker(e.detail);
});
function giveConsentEtracker(detail) {
	//if (detail !== null && typeof detail.aff_consent_adcell !== 'undefined') {
	//	CheckConsentEtracker(detail, 'etracker');
	//}

	if (detail !== null && typeof detail.etracker_consent_etracker !== 'undefined') {
		if (detail.etracker_consent_etracker === true) {
			setTimeout(function(){ 
				_etracker.enableCookies(window.location.hostname);
				console.log('Consent für etracker gewährt: ' + window.location.hostname + ' - ' + _etracker.areCookiesEnabled() + ' - ' + getCookieValue("et_allow_cookies"));
			}, 1000);
		} else {
			setTimeout(function(){ 
				_etracker.disableCookies(window.location.hostname);
				console.log('Consent für etracker entzogen: ' + window.location.hostname + ' - ' + _etracker.areCookiesEnabled() + ' - ' + getCookieValue("et_allow_cookies"));
			}, 1000);
		}
	}
}

function CheckConsentEtracker(detail, service, dependencies = '') {
	if (eval('detail.aff_consent_' + service) === true) {
		if (dependencies == '') {
			$('head script[data-etracker-cmp-id="' + service  + '"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						AffilateAddScript(service, index, f, document.head, detail);
					}, 200, this);
				}
			});
			$('body script[data-etracker-cmp-id="' + service  + '"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						AffilateAddScript(service, index, f, document.body, detail);
					}, 200, this);
				}
			});
			console.log('Consent für ' + service  + ' gewährt');
		} else {
			$('head script[data-etracker-cmp-id="' + service  + '"][data-dep-id="' + dependencies  + '"]').each(function (index) {
				setTimeout (function(f){
					AffilateAddScript(service, index, f, document.head, detail);
				}, 200, this);
			});
			$('body script[data-etracker-cmp-id="' + service  + '"][data-dep-id="' + dependencies  + '"]').each(function (index) {
				setTimeout (function(f){
					AffilateAddScript(service, index, f, document.body, detail);
				}, 200, this);
			});
			console.log('Consent für ' + service  +  ' (dep ' + dependencies + ') gewährt');
		}
	} else {
		console.log('Consent für ' + service  + ' entzogen');
	}
}

function AffilateAddScript(service, index, element, parent, detail) {
	var script = document.createElement("script");
	script.setAttribute("type", "text/javascript");
	script.async = true;
	script.defer = true;
	if (typeof $(element).attr('src') !== "undefined") {
		script.setAttribute("src", $(element).attr('src'));
	//	if (typeof $(element).attr('data-onload') !== "undefined") {
		//		//script.addEventListener('load', $(element).attr('data-onload'));
	//		script.onload = eval('window.onload = function() {' + $(element).attr('data-onload') + '};');
	//		console.log('loaded');
	//	}
	}
	//console.log($(element).text());
	//script.innerText =  $(element).text();
	setInnerHTML(script, $(element).text());
	script.setAttribute("data-etracker-cmp-set-id", service);
	script.setAttribute("data-etracker-consent-given", "true");
	if (element.hasAttribute('data-dependencies')) {
		script.addEventListener("load", function(event) {
			console.log(service + ': dependencies on src');
			CheckConsentEtracker(detail, service, element.getAttribute('data-dependencies'));
		});
		if (!script.hasAttribute('src')) {
			console.log(service + ': dependencies without src');
			CheckConsentEtracker(detail, service, element.getAttribute('data-dependencies'));
		}
	}
	element.parentNode.replaceChild(script, element);
}

var setInnerHTML = function(elm, html) {
  elm.innerHTML = html;
  Array.from(elm.querySelectorAll("script")).forEach( oldScript => {
    const newScript = document.createElement("script");
    Array.from(oldScript.attributes)
      .forEach( attr => newScript.setAttribute(attr.name, attr.value) );
    newScript.appendChild(document.createTextNode(oldScript.innerHTML));
    oldScript.parentNode.replaceChild(newScript, oldScript);
  });
}

function getCookieValue(a) {
   const b = document.cookie.match('(^|;)\\s*' + a + '\\s*=\\s*([^;]+)');
   return b ? b.pop() : '';
}


